<template>
  <VForm
    name="topic-update-form"
    :fields="fields"
    :modelState="modelState"
    buttonText="Update"
    buttonIconClass="bi bi-save-fill"
    :busy="updating"
    busyButtonText="Updating..."
    @field-input="onFieldInput"
    @submit="onSubmit"
  />
</template>

<script>
import { ref, computed, watch } from 'vue'
import { useRouter } from 'vue-router'
import { VForm, useApi, useNotification } from '../../core'
import { useAuth } from '../../identity'
import TopicsApi from '../api/topics-api.js'

export default {
  name: 'TopicUpdateForm',
  components: {
    VForm,
  },
  props: {
    topic: { type: Object, required: true },
  },
  setup(props) {
    const router = useRouter()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const topicsApi = new TopicsApi(api, auth)

    const topicInternal = ref(props.topic)
    const modelState = ref({})
    const updating = ref(false)

    const fields = computed(() => {
      return [
        {
          type: 'hidden',
          name: 'sectionId',
          value: topicInternal.value.sectionId,
        },
        {
          type: 'radio',
          inline: true,
          name: 'imageAuto',
          label: 'Thumbnail image',
          value: topicInternal.value.imageAuto ? 'true' : 'false',
          options: [
            { value: 'true', text: 'Automatic' },
            { value: 'false', text: 'Manual' },
          ],
        },
        {
          type: 'galleryimages',
          name: 'imageId',
          multiselect: false,
          disabled: topicInternal.value.imageAuto,
          value: topicInternal.value.imageId,
        },
        {
          type: 'text',
          name: 'title',
          label: 'Title',
          maxlength: 200,
          validate: 'required',
          value: topicInternal.value.title,
        },
        {
          type: 'text',
          name: 'subHeading',
          label: 'Sub-heading',
          maxlength: 200,
          value: topicInternal.value.subHeading,
        },
      ].concat(
        topicInternal.value && topicInternal.value.section && topicInternal.value.section.classifieds
          ? [
              {
                type: 'number',
                name: 'price',
                label: 'Price',
                tooltip:
                  '"For Sale" items must have a price. "Multiple" items should have a price per item in the description.',
                validate: 'required|decimal:2',
                value: topicInternal.value.price,
              },
              {
                type: 'radio',
                name: 'status',
                label: 'Status',
                validate: 'required',
                value: topicInternal.value.status,
                options: [
                  {
                    value: '1',
                    text: 'For Sale',
                  },
                  {
                    value: '2',
                    text: 'Multiple Items',
                  },
                  {
                    value: '3',
                    text: 'E.O.I',
                  },
                  {
                    value: '4',
                    text: 'Pending Payment',
                  },
                  {
                    value: '5',
                    text: 'Sold',
                  },
                ],
              },
            ]
          : []
      )
    })

    const onFieldInput = (field) => {
      if (field.name === 'imageAuto') {
        topicInternal.value.imageAuto = field.value === 'true'
        return
      }

      topicInternal.value[field.name] = field.value
    }

    const onSubmit = async (form) => {
      updating.value = true

      try {
        const response = await topicsApi.updateAsync(topicInternal.value.id, form)
        notify.success('Topic updated successfully.')
        router.push({
          name: 'forum-topic',
          params: { alias: response.data.alias },
        })
      } catch (ex) {
        if (ex.response.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else {
          notify.error('There was a problem updating the topic.', ex)
        }
      } finally {
        updating.value = false
      }
    }

    watch(
      () => props.topic,
      () => {
        topicInternal.value = JSON.parse(JSON.stringify(props.topic))
      }
    )

    return {
      topicInternal,
      modelState,
      updating,
      fields,
      onFieldInput,
      onSubmit,
    }
  },
}
</script>
